<template>
  <v-card>
    <v-card-title>Assign labels</v-card-title>
    <v-divider />
    <v-card-text>
      <v-autocomplete
        id="label-add-autocomplete"
        :items="feedbackLabels"
        item-text="name"
        item-value="pk"
        append-icon="search"
        placeholder="search for keywords"
        @keyup.enter.ctrl.exact="submitFeedback"
        @input="addLabel"
      >
        <template #item="{ item }">
          <div class="label-adder-item">
            <feedback-label v-bind="item" />
          </div>
        </template>
      </v-autocomplete>
      <v-row>
        <v-col md="4">
          <div>
            CURRENT LABELS
          </div>
          <feedback-label
            v-for="label in unchangedMapped"
            :key="label.pk"
            removable
            v-bind="label"
            @remove-clicked="removeLabel"
          />
        </v-col>
        <v-col md="4">
          <div>
            WILL BE REMOVED
          </div>
          <feedback-label
            v-for="label in removedMapped"
            :key="label.pk"
            removable
            v-bind="label"
            @remove-clicked="addLabel"
          />
        </v-col>
        <v-col md="4">
          <div>
            WILL BE ADDED
          </div>
          <feedback-label
            v-for="label in addedMapped"
            :key="label.pk"
            removable
            v-bind="label"
            @remove-clicked="removeLabel"
          />
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'
import Component from 'vue-class-component'
import { Prop } from 'vue-property-decorator'
import { FeedbackLabels } from '@/store/modules/feedback-labels'
import { SubmissionNotes } from '@/store/modules/submission-notes'
import FeedbackLabel from '@/components/feedback_labels/FeedbackLabel.vue'
import { FeedbackComment, SubmissionType } from '../../models'

@Component({
  components: {
    FeedbackLabel,
  }
})
export default class LabelSelector extends Vue {
  @Prop({ type: String }) readonly lineNo!: string
  @Prop({ type: Boolean, required: true }) readonly assignedToFeedback!: boolean
  @Prop({ type: Array }) readonly labelsUnchanged!: number[]
  @Prop({ type: Array }) readonly labelsAdded!: number[]
  @Prop({ type: Array }) readonly labelsRemoved!: number[]

  get feedbackLabels () {
    return FeedbackLabels.availableLabels
  }

  get unchangedMapped() {
    if (this.assignedToFeedback) {
      return this.mapPksToLabelObj(this.unchangedFeedbackLabels())
    } else {
      return this.mapPksToLabelObj(this.labelsUnchanged)
    }
  }

  get removedMapped() {
    if (this.assignedToFeedback) {
      return this.mapPksToLabelObj(this.removedFeedbackLabels())
    } else {
      return this.mapPksToLabelObj(this.labelsRemoved)
    }
  }

  get addedMapped() {
    if (this.assignedToFeedback) {
      return this.mapPksToLabelObj(this.addedFeedbackLabels())
    } else {
      return this.mapPksToLabelObj(this.labelsAdded)
    }
  }

  /**
   * Returns an array of label pk's that have not changed from origFeedback to updatedFeedback
   */
  unchangedFeedbackLabels() {
    const labelsOrig = SubmissionNotes.state.origFeedback.labels
    if (labelsOrig === undefined) return new Array()

    const labelsDeleted = this.removedFeedbackLabels()
    const labelsAdded = this.addedFeedbackLabels()

    return labelsOrig.filter((label) => {
      return !labelsAdded.includes(label) && !labelsDeleted.includes(label)
    })
  }

  /**
   * Returns an array of label pk's that have been removed in updatedFeedback
   * but exist in origFeedback
   */
  removedFeedbackLabels() {
    if (!SubmissionNotes.state.changedLabels) return new Array()

    const labelsOrig = SubmissionNotes.state.origFeedback.labels
    const labelsUpdated = SubmissionNotes.state.updatedFeedback.labels

    if (labelsOrig === undefined) return new Array()

    return labelsOrig.filter((label) => {
      return !labelsUpdated.includes(label)
    })
  }

  /**
   * Returns an array of label pk's that have been added in updatedFeedback
   * but do not exist in origFeedback
   */
  addedFeedbackLabels() {
    const labelsOrig = SubmissionNotes.state.origFeedback.labels
    const labelsUpdated = SubmissionNotes.state.updatedFeedback.labels

    if (labelsOrig === undefined) return new Array()

    return labelsUpdated.filter((label) => {
      return !labelsOrig.includes(label)
    })
  }

  /**
   * Maps label pk's to the objects stored in vuex store
   */
  mapPksToLabelObj(pkArr: number[]): FeedbackLabel[] {
    const mappedLabels = pkArr.map((val) => {
      const label = FeedbackLabels.availableLabels.find((label) => {
        return label.pk === val
      })

      if (!label) return
      return {
        pk: val,
        name: label.name,
        description: label.description,
        colour: label.colour
      }
    })

    return mappedLabels ? mappedLabels : new Array()
  }

  /**
   * Removes given label from the feedback or fires an event
   * to remove the label from a comment
   */
  removeLabel(pk: number) {
    if (this.assignedToFeedback) {
      if (!SubmissionNotes.state.changedLabels) {
        SubmissionNotes.SET_FEEDBACK_LABELS([...SubmissionNotes.state.origFeedback.labels])
      }

      SubmissionNotes.REMOVE_FEEDBACK_LABEL(pk)
    } else {
      this.$emit('label-removed', pk)
    }
  }

  /**
   * Adds the given label to the feedback or fires an event
   * to add the label to a comment
   * Calling this with an already added label will instead remove the label
   */
  addLabel(pk: number) {
    if (this.assignedToFeedback) {
      if (!this.unchangedFeedbackLabels().includes(pk) &&
          !this.addedFeedbackLabels().includes(pk))
      {
          if (!SubmissionNotes.state.changedLabels) {
            SubmissionNotes.SET_FEEDBACK_LABELS([...SubmissionNotes.state.origFeedback.labels])
          }

          SubmissionNotes.ADD_FEEDBACK_LABEL(pk)
      }
    } else {
      this.$emit('label-added', pk)
    }
  }

  /**
   * Emits an event which tells the parent that
   * the submit shortcut was pressed
   */
  submitFeedback() {
    this.$emit('submit-shortcut')
  }
}
</script>

<style>
</style>
